##  for PCLinuxOS  ##

%define ver 1.8.9
%define rel 1

%define git 0
%define git_date 20220819
%if %{git}
%define realrel %{rel}.%{git_date}.nora22
%else
%define realrel %{rel}.nora22
%endif

%define anthy_version 9100h
%define m17n_lib_version 1.7.0

%define with_qt4 0


Name:    uim
Summary: Uim is a multilingual input method library
Summary(ja):  Uim - 入力メソッドライブラリ
Version: %{ver}
Release: %{realrel}
Group:   System/Internationalization
License: BSD, LGPLv2 and GPL
URL:     https://github.com/uim/uim

%if %{git}
Source0: %{name}-%{git_date}.tar.xz
#Source1: get-uim-trunk-code.sh
%else
Source0: https://github.com/uim/uim/releases/download/%{name}-%{version}/%{name}-%{version}.tar.bz2
%endif
Source10: uim.desktop

# patch11 from Fedora
Patch11: uim-emacs-utf8.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: libxft-devel
BuildRequires: libx11-devel
BuildRequires: libxext-devel
BuildRequires: libxrender1-devel
BuildRequires: libxau6-devel
BuildRequires: libxdmcp-devel
BuildRequires: libxt-devel
BuildRequires: libgtk+2-devel
BuildRequires: libgtk+3-devel
BuildRequires: libglade2.0-devel
BuildRequires: anthy-devel >= %{anthy_version}
BuildRequires: libncurses-devel
BuildRequires: intltool
BuildRequires: automake
BuildRequires: libtool
BuildRequires: gettext-devel
BuildRequires: libopenssl-devel
BuildRequires: libcurl-devel
BuildRequires: GConf2-devel
BuildRequires: libsm-devel
BuildRequires: emacs
BuildRequires: cmake
BuildRequires: m17n-lib-devel >= %{m17n_lib_version}
BuildRequires: m17n-db-devel
BuildRequires: librsvg2-devel
BuildRequires: asciidoc
%if %{with_qt4}
BuildRequires: libqt4-devel
%endif
#
BuildRequires: qt5core-devel
BuildRequires: qt5widgets-devel
BuildRequires: qt5x11extras-devel
BuildRequires: %{_lib}kf5plasma-devel
#
%if %{git}
BuildRequires: ruby
%endif

Requires: uim-gtk3 = %{version}-%{release}
Requires: setime >= 1.6

%description
Uim is a multilingual input method library.
Uim's project goal is to provide secure and useful input method for all languages.

[WARNING]
This UNOFFICIAL package do NOT support Canna, PRIME, Mana.
%if ! %{with_qt4}
This UNOFFICIAL package do NOT include Qt4 plugins.
%endif

%description -l ja
uim は様々な言語の入力メソッドのライブラリーです。

【注意】
この野良パッケージでは canna, prime, mana はサポートしていません。
%if ! %{with_qt4}
この野良パッケージでは Qt4 用のプラグインを含んでいません。
%endif

%post
#if [ $1 = 1 ]; then
#%%{_bindir}/uim-module-manager --unregister-all > /dev/null 2>&1
#fi
if [ $1 = 2 ]; then
  if [ $(rpm -q --quiet uim-mozc) -o $(rpm -q --quiet uim-mozc-ut-neologd) ]; then
    %{_bindir}/uim-module-manager --register mozc > /dev/null 2>&1
  fi
fi

# --------------------------------------------------------------

%package gtk2
Summary: gtk+2 helper for Uim
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: gtk+2
Provides: uim-gtk
Requires(post,postun): gtk+2

%description gtk2
gtk+2 helper for Uim.
It contains some apps like toolbar, system tray, applet, candidate window for Uim library.

%post gtk2
%{_libdir}/gtk-2.0/bin/gtk-query-immodules-2.0 --update-cache

%postun gtk2
if [ $1 = 0 ]; then
%{_libdir}/gtk-2.0/bin/gtk-query-immodules-2.0 --update-cache
fi

# -------------------------------------------------------------

%package gtk3
Summary: gtk+3 support for Uim
Summary(ja): uim の gtk+3 用モジュール
Group: System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires(post,postun): gtk+3.0

%description gtk3
gtk+3 helper for Uim.
This package contains some applications like toolbar, system tray, input pad, candidate window, and preference tool using GTK+3.

%description -l ja gtk3
このパッケージには、GTK+3 を使ったツールバーやシステムトレイ、入力パッド、候補ウィンドウ、設定ツールなどが含まれています。

%post gtk3
gtk-query-immodules-3.0-%{__isa_bits} --update-cache

%postun gtk3
if [ $1 = 0 ]; then
gtk-query-immodules-3.0-%{__isa_bits} --update-cache
fi

# -----------------------------------------------------------

%if %{with_qt4}
%package qt4
Summary: Qt4 support for Uim
Summary(ja): Uim の Qt4 サポート
Group: System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: qt4-common >= 4.7.1
Requires: oxygen-icons5
Provides: uim-qt4immodule

%description qt4
This package contains some applications like toolbar, candidate window, and preference tool using Qt4.

%description -l ja qt4
このパッケージには、Qt4 を使ったツールバーや設定ツールなどが含まれています。
%endif

# -----------------------------------------------------------

%package qt5
Summary: Qt5 support for Uim
Summary(ja): Uim の Qt5 サポート
Group: System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: %{_lib}qt5core5
Requires: oxygen-icons5
Provides: uim-qt5immodule

%description qt5
This package contains some graphical utilities (but not a full IM-module) using Qt 5.x.

%description -l ja qt5
このパッケージには、Qt5 を使ったツールバーや設定ツールなどが含まれています。

# -----------------------------------------------------------

%package anthy
Summary: Anthy support for Uim
Summary(ja): Uim の Anthy モジュール
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: anthy >= %{anthy_version}
Requires(post,preun): %{name} = %{version}

%description anthy
This package provides support for Anthy, a Japanese input method.

%description -l ja anthy
Uim 上で連文節かな漢字変換エンジン Anthy を使って日本語を入力・変換するためのモジュールです。

%post anthy
%{_bindir}/uim-module-manager --register anthy-utf8 > /dev/null 2>&1 || :

%preun anthy
if [ "$1" = "0" ]; then
%{_bindir}/uim-module-manager --unregister anthy-utf8 > /dev/null 2>&1 || :
fi

# -----------------------------------------------------------

%package skk
Summary: SKK support for Uim
Summary(ja): Uim の SKK モジュール
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: skkdic
Requires(post,preun): %{name} = %{version}

%description skk
This package provides support for SKK, a Japanese input method.

%description -l ja skk
Uim 上で SKK 入力方式を使って日本語を入力するためのモジュールです。

%post skk
%{_bindir}/uim-module-manager --register skk > /dev/null 2>&1 || :

%preun skk
if [ $1 = 0 ] ; then
%{_bindir}/uim-module-manager --unregister skk > /dev/null 2>&1 || :
fi

# --------------------------------------------------------------

%package m17n
Summary: m17n-lib support for Uim
Summary(ja): Uim の m17n-lib モジュール
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: m17n-lib >= %{m17n_lib_version}
Requires(post,preun): %{name} = %{version}

%description m17n
This package provides support for m17n-lib, which allows input of many languages using the input table map from m17n-db.

%post m17n
%{_bindir}/uim-module-manager --register m17nlib > /dev/null 2>&1 || :

%preun m17n
if [ "$1" = "0" ]; then
%{_bindir}/uim-module-manager --unregister m17nlib > /dev/null 2>&1 || :
fi

# --------------------------------------------------------------

%package devel
Summary: Headers of Uim for development
Summary(ja): Uim を使ったアプリケーションを開発するためのファイル
Group:   Development/C
Requires: %{name} = %{version}-%{release}

%description devel
Headers of Uim for development.

%description -l ja devel
このパッケージには Uim を利用したアプリケーションを開発するためのヘッダファイルとライブラリが含まれています。

# --------------------------------------------------------------

%prep
%if %{git}
%setup -q -n uim-%{git_date}
%else
%setup -q
#./autogen.sh
%endif

%apply_patches

sed -i 's|uim-dict-gtk|uim-dict-gtk3|g' qt4/toolbar/common-quimhelpertoolbar.cpp


%build
%if %{with_qt4}
export QMAKE4=%{_libdir}/qt4/bin/qmake
%endif
export QMAKE5=%{_libdir}/qt5/bin/qmake

# workaround for build error
CFLAGS="$CFLAGS -fcommon"

CONF_OPTION="--libexecdir=%{_libdir}/uim \
--with-x --with-xft \
--with-anthy-utf8 --without-anthy \
--without-canna --without-mana --without-prime \
--enable-openssl --with-curl --with-expat \
--with-fep --enable-pref --enable-dict \
--with-gtk --with-gtk3 \
%if %{with_qt4}
--with-qt4 --with-qt4-immodule \
%endif
--with-qt5 --with-qt5-immodule \
--disable-kde-applet --disable-kde4-applet \
--disable-gnome-applet --disable-gnome3-applet \
--disable-rpath --disable-static --disable-warnings-into-error \
--without-eb"

%if %{git}
%configure2_5x $CONF_OPTION --enable-maintainer-mode
%else
%configure2_5x $CONF_OPTION
%endif

%make_build 


%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std

## install desktop entry
cp -f %{SOURCE10} $RPM_BUILD_ROOT%{_datadir}/applications/
mkdir -p $RPM_BUILD_ROOT%{_iconsdir}/hicolor/{48x48,64x64}/apps
cp $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/uim-icon48.png $RPM_BUILD_ROOT%{_iconsdir}/hicolor/48x48/apps/uim-icon.png
cp $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/uim-icon64.png $RPM_BUILD_ROOT%{_iconsdir}/hicolor/64x64/apps/uim-icon.png

## remove unnecessary files
find $RPM_BUILD_ROOT -name *.la | xargs rm

rm -f $RPM_BUILD_ROOT%{_datadir}/uim/anthy.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/anthy-custom.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/scim.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/prime*.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/canna*.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/mana*.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/scim.*
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/prime*.*
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/canna.*
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/mana.*

## remove docs for sigscheme (they should be installed by %%doc)
rm -rf $RPM_BUILD_ROOT%{_datadir}/doc/sigscheme

%find_lang %{name}


%files -f %{name}.lang
%defattr(-,root,root)
%doc AUTHORS COPYING README* INSTALL*
%doc sigscheme/doc/*
%{_bindir}/uim-el*-agent
%{_bindir}/uim-module-manager
%{_bindir}/uim-sh
%{_bindir}/uim-xim
%{_bindir}/uim-help
%{_bindir}/uim-fep
%{_bindir}/uim-fep-tick
%{_datadir}/applications/uim.desktop
%{_datadir}/emacs/site-lisp/uim-el/*.el
%{_datadir}/man/man1/*
%{_datadir}/uim/*.scm
%exclude %{_datadir}/uim/anthy*.scm
%exclude %{_datadir}/uim/skk*.scm
%exclude %{_datadir}/uim/m17n*.scm
%{_datadir}/uim/lib/*.scm
%{_datadir}/uim/helperdata/*
%{_datadir}/uim/pixmaps/*
%exclude %{_datadir}/uim/pixmaps/anthy.*
%exclude %{_datadir}/uim/pixmaps/skk.*
%exclude %{_datadir}/uim/pixmaps/m17n*
%{_datadir}/uim/tables/*.table
%{_datadir}/uim/byeoru-data/byeoru-dict
%{_libdir}/lib*.so.*
%{_libdir}/uim/plugin/libuim-*.so
%exclude %{_libdir}/uim/plugin/libuim-anthy-utf8.so
%exclude %{_libdir}/uim/plugin/libuim-skk.so
%exclude %{_libdir}/uim/plugin/libuim-m17nlib.so
%{_libdir}/uim/uim-helper-server
%{_iconsdir}/hicolor/*/apps/uim-icon.png

%files gtk2
%defattr(-,root,root)
%{_bindir}/uim-input-pad-ja
%{_bindir}/uim-dict-gtk
%{_bindir}/uim-im-switcher-gtk
%{_bindir}/uim-pref-gtk
%{_bindir}/uim-toolbar-gtk
%{_bindir}/uim-toolbar-gtk-systray
%{_libdir}/uim/uim-candwin-gtk
%{_libdir}/uim/uim-candwin-horizontal-gtk
%{_libdir}/uim/uim-candwin-tbl-gtk
%{_libdir}/gtk-2.0/*/immodules/*.so

%files gtk3
%defattr(-,root,root)
%{_bindir}/uim-dict-gtk3
%{_bindir}/uim-im-switcher-gtk3
%{_bindir}/uim-input-pad-ja-gtk3
%{_bindir}/uim-pref-gtk3
%{_bindir}/uim-toolbar-gtk3
%{_bindir}/uim-toolbar-gtk3-systray
%{_libdir}/gtk-3.0/3.0.0/immodules/im-uim.so
%{_libdir}/uim/uim-candwin-gtk3
%{_libdir}/uim/uim-candwin-horizontal-gtk3
%{_libdir}/uim/uim-candwin-tbl-gtk3

%if %{with_qt4}
%files qt4
%defattr(-,root,root)
%{_bindir}/uim-chardict-qt4
%{_bindir}/uim-im-switcher-qt4
%{_bindir}/uim-pref-qt4
%{_bindir}/uim-toolbar-qt4
%{_libdir}/uim/uim-candwin-qt4
%{_libdir}/qt4/plugins/inputmethods/libuiminputcontextplugin.so
%endif

%files qt5
%defattr(-,root,root)
%{_bindir}/uim-chardict-qt5
%{_bindir}/uim-im-switcher-qt5
%{_bindir}/uim-pref-qt5
%{_bindir}/uim-toolbar-qt5
%{_libdir}/uim/uim-candwin-qt5
%{_libdir}/qt5/plugins/platforminputcontexts/libuimplatforminputcontextplugin.so
%{_libdir}/qt5/qml/com/github/uim/libuim-qtquick-plugin.so
%{_libdir}/qt5/qml/com/github/uim/qmldir
%{_datadir}/kservices5/plasma-applet-com.github.uim.status.desktop
%{_datadir}/metainfo/com.github.uim.status.appdata.xml
%{_datadir}/plasma/plasmoids/com.github.uim.status/contents/ui/main.qml
%{_datadir}/plasma/plasmoids/com.github.uim.status/contents/ui/messageProcessor.js
%{_datadir}/plasma/plasmoids/com.github.uim.status/metadata.desktop
%{_datadir}/plasma/plasmoids/com.github.uim.status/metadata.json

%files	anthy
%defattr(-,root,root)
%{_libdir}/uim/plugin/libuim-anthy-utf8.so
%{_datadir}/uim/anthy*.scm
%{_datadir}/uim/pixmaps/anthy*.png

%files skk
%defattr(-,root,root)
%{_libdir}/uim/plugin/libuim-skk.so
%{_datadir}/uim/skk*.scm
%{_datadir}/uim/pixmaps/skk.*

%files m17n
%defattr(-,root,root)
%{_bindir}/uim-m17nlib-relink-icons
%{_libdir}/uim/plugin/libuim-m17nlib.so
%{_datadir}/uim/m17nlib.scm
%{_datadir}/uim/m17nlib-custom.scm
%{_datadir}/uim/pixmaps/m17n*

%files devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*.pc


%changelog
* Tue Aug 23 2022 tomcat <> 1.8.9-1
- 1.8.9
- add '-fcommon' option to CFLAGS due to build error on gcc12

* Tue Mar 22 2022 tomcat <> 1.8.9-0.20220318
- update to 20220318 (rev.6d8fcc8)
- update %%files
- fix %%post
- now do not build qt4 plugins

* Sat Apr 03 2021 tomcat <> 1.8.9-0.1.d1ac9d9
- git:d1ac9d9
- sprit gtk+2 im module as uim-gtk2 sub package
- fix BuildRequires
- update %%files

* Mon Feb 18 2019 tomcat <> 1.8.8-5.git20190210
- git:20190210

* Sat Feb 09 2019 tomcat <> 1.8.8-4.git20190207
- git:20190207

* Thu Oct 25 2018 tomcat <> 1.8.8-3.git20181025
- git:20181025

* Sat May 12 2018 tomcat <> 1.8.8-2
- use official tarball
- drop Source1 (get-uim-1.8.8-source.sh)
- add './autogen.sh' into %%prep section

* Sat May 12 2018 tomcat <> 1.8.8-1
- update to 1.8.8
- update Source1 (get-uim-1.8.8-source.sh)

* Fri May 11 2018 tomcat <> 1.8.7-1
- update to 1.8.7
- update %%files
- add Source1 (get-uim-1.8.7-source.sh)

* Thu Mar 01 2018 tomcat <> 1.8.6-25.git20180301
- git.20180301
- drop Patch22 (qt5-disable-debug-flag.patch) merged upstream

* Thu Mar 01 2018 tomcat <> 1.8.6-24.git20180228
- git.20180228
- update Source1
- update %%prep section

* Mon Jan 15 2018 tomcat <> 1.8.6-23.git20180114
- git.20180114

* Tue Jan 08 2018 tomcat <> 1.8.6-22.git20180108
- git.20180108

* Sat Jan 06 2018 tomcat <> 1.8.6-21.git20180106
- git.20180106
- remove 'export RUBYOPT=-EUTF-8' fro %%build section

* Tue Dec 12 2017 tomcat <> 1.8.6-20.git20171105
- rebuild against Qt 5.10.0

* Sun Nov 05 2017 tomcat <> 1.8.6-19.git20171105
- git.20171105

* Sun Oct 01 2017 tomcat <> 1.8.6-18.git20171001
- git.20171001

* Fri Aug 25 2017 tomcat <> 1.8.6-17.git20170825
- git.20170825
- clean up spec file
- Patch11 (uim-emacs-utf8.patch) from Fedoa
- Patch22 (qt5-disable-debug-flag.patch) from Debian 
- add R:oxygen-icons5 into uim-qt4 and uim-qt5 sub packages
- unregistered all modules in default
